#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>

using namespace std;

const int n = 14;
const int maxm = n*n;
const int maxT = 1024;

int m, T, U;
int u[maxm], v[maxm], t[maxm];
int g[n], next[maxm];
int vis[maxT][n], fr[maxT][n];

void add(int i)
{
	next[i] = g[u[i]]; g[u[i]] = i;
}

void dfs(int cur_t, int x)
{
	vis[cur_t][x] = 1;
	int i = g[x];
	while (i) {
		int t1 = cur_t + t[i];
		if (t1 <= T && !vis[t1][v[i]]) {
			fr[t1][v[i]] = i;
			dfs(t1, v[i]);
		}
		i = next[i];
	}
}

void rec(int cur_t, int x)
{
	if (cur_t) rec(cur_t - t[fr[cur_t][x]], u[fr[cur_t][x]]);
	cout << x << " ";
}

int main()
{
	freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

	int i;
	cin >> m >> T >> U;
	for (i = 1; i <= m; i++) {
		cin >> u[i] >> v[i] >> t[i];
		u[m+i] = v[i]; v[m+i] = u[i]; t[m+i] = t[i];
		add(i); add(m+i);
	}

	dfs(0, U);

	if (vis[T][U]) {
		cout << "YES" << endl;
		rec(T, U);
	} else cout << "NO" << endl;

	fclose(stdin); fclose(stdout);
	return 0;   
}
